<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <title>Orders Admin | Dashboard</title>

  <!-- Google Font: Source Sans Pro -->
  <link rel="stylesheet" href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
  <!-- Font Awesome -->
  <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
  <!-- Ionicons -->
  <link rel="stylesheet" href="https://code.ionicframework.com/ionicons/2.0.1/css/ionicons.min.css">
  <!-- Data Table-->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <!-- Theme style -->
  <link rel="stylesheet" href="dist/css/adminlte.min.css">
  
</head>
<body class="hold-transition sidebar-mini layout-fixed">
<div class="wrapper">

    <!-- Navbar -->
  <nav class="main-header navbar navbar-expand navbar-white navbar-light">
    <!-- Left navbar links -->
    <ul class="navbar-nav">
      <li class="nav-item">
        <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="Task 45.50.html" class="nav-link">Home</a>
      </li>
      <li class="nav-item d-none d-sm-inline-block">
        <a href="#" class="nav-link">Orders</a>
      </li>
    </ul>
  </nav>
  <!-- /.navbar -->

  <!-- Main Sidebar Container -->
  <aside class="main-sidebar sidebar-dark-primary elevation-4">
    <!-- Brand Logo -->
    <a href="index3.html" class="brand-link">
      <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3" style="opacity: .8">
      <span class="brand-text font-weight-light">Devcamp120</span>
    </a>

    <!-- Sidebar -->
    <div class="sidebar">
      <!-- Sidebar user panel (optional) -->
      <div class="user-panel mt-3 pb-3 mb-3 d-flex">
        <div class="image">
          <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
        </div>
        <div class="info">
          <a href="#" class="d-block">Phuonglhm</a>
        </div>
      </div>

      <!-- Sidebar Menu -->
      <nav class="mt-2">
        <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu" data-accordion="false">
          <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
          <li class="nav-item menu-open">
            <a href="#" class="nav-link active">
              <i class="nav-icon fas fa-tachometer-alt"></i>
              <p>
                Dashboard
                <i class="right fas fa-angle-left"></i>
              </p>
            </a>
            <ul class="nav nav-treeview">
              <li class="nav-item">
                <a href="../Task 45.30 CRUD voucher/Task 45.30.html" class="nav-link ">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Vouchers</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="../Task 45.40 CRUD USERS/45.40.html" class="nav-link">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Người dùng</p>
                </a>
              </li>
              <li class="nav-item">
                <a href="Task 45.30.html" class="nav-link active">
                  <i class="far fa-circle nav-icon"></i>
                  <p>Quản trị Orders</p>
                </a>
              </li>
            </ul>
          </li>
        </ul>
      </nav>
      <!-- /.sidebar-menu -->
    </div>
    <!-- /.sidebar -->
  </aside>

  <!-- Content Wrapper. Contains page content -->
  <div class="content-wrapper">
    <!-- Content Header (Page header) -->
    <div class="content-header">
      <div class="container-fluid">
        <div class="row mb-2">
          <div class="col-sm-6">
            <h1 class="m-0">Orders Management</h1>
          </div><!-- /.col -->
          <div class="col-sm-6">
            <ol class="breadcrumb float-sm-right">
              <li class="breadcrumb-item"><a href="#">Home</a></li>
              <li class="breadcrumb-item active">Orders</li>
            </ol>
          </div><!-- /.col -->
        </div><!-- /.row -->
      </div><!-- /.container-fluid -->
    </div>
    <!-- /.content-header -->

    <!-- Main content -->
    <section class="content">
      <div class="container-fluid">
       
        <div class="container">
          <h2 style="text-align: center;">Danh sách Đơn hàng</h2>
          <div class="container jumbotron">
              <div class="row form-group">
                  <div class="col-md-5 row">
                      <div class="col-md-6 text-center">
                          <label class="form-group mx-2"> Trạng thái order</label>
                      </div>
                      <div class="col-md-6">
                          <select class="form-control" id="sel-status">
                              <option value="all">All</option>
                              <option value="open">Open</option>
                              <option value="confirmed">Confirmed</option>
                              <option value="cancel">Cancel</option>
  
                          </select>
                      </div>
                  </div>
                  <div class="col-md-5 row">
                      <div class="col-md-6 text-center">
                          <label class="form-group mx-2"> Loại pizza </label>
                      </div>
                      <div class="col-md-6">
                          <select class="form-control" id="sel-pizza">
                              <option value="all">All</option>
                              <option value="hawaii">Hawaii</option>
                              <option value="bacon">Bacon</option>
                              <option value="seafood">Seafood</option>
                          </select>
                      </div>
                  </div>
                  <div class="col-md-2 row">
                      <div class="col-md-12 text-right">
                          <button class="btn btn-success" id="btn-filter"> Lọc </button>
                      </div>
                  </div>
              </div>
          </div>
          <table class="table table-hover table-striped table-bordered" id="table-order">
              <thead class="mb-3 bg-info bg-gradient">
                  <tr>
                      <th>Order ID</th>
                      <th>Kích cỡ combo</th>
                      <th>Loại pizza</th>
                      <th>Nước uống</th>
                      <th>Thành tiền</th>
                      <th>Họ và tên</th>
                      <th>Số điện thoại</th>
                      <th>Trạng thái</th>
                      <th>Action</th>
                  </tr>
              </thead>
          </table>
      </div>
  <!-- Vùng Modal -->
  
  <div>
      <div id="Order-details-modal" class="modal fade" tabindex="-1">
        <div class="modal-dialog modal-lg">
          <div class="modal-content">
              <!--modal header-->
            <div class="modal-header">
              <h5 class="modal-title" >Order Details</h5>
              <button type = "button" class="close" data-dismiss="modal">&times;</button>
            </div>
            <!--modal body-->
            <div class="modal-body">
              <form>
                  <div class="row form-group">
                      <div class="col-md-3">
                        <label >ID :</label>
                      </div>
                      <div class="col-md-9">
                        <input type="text" id="input-id"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Order ID</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-orderId"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Pizza Size:</label>
                      </div>
                      <div class="col-md-9">
                      <select type="text" id="select-pizzasize"  class="form-control"></select>
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Đường kính:</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-duongKinh"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Sườn:</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-suon"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Salad:</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-salad"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >PizzaType:</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-pizzaType"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >ID Voucher:</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-idVoucher"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Thành tiền</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-thanhtien"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Giảm giá</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-giamgia"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Loại đồ uống</label>
                      </div>
                      <div class="col-md-9">
                      <select type="select" id="select-drink"  class="form-control"></select>
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Số lượng nước uống</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-soluongdrink"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Họ và Tên</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-fullname"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Email</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-email"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Số Điện thoại</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-phone"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                      <label >Địa chỉ</label>
                      </div>
                      <div class="col-md-9">
                      <input type="text" id="input-address"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                          <label >Lời nhắn</label>
                      </div>
                      <div class="col-md-9">
                          <input type="text" id="input-message"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                          <label >Ngày Order</label>
                      </div>
                      <div class="col-md-9">
                          <input type="text" id="input-orderday"  class="form-control">
                      </div>
                  </div>
                  <div class="row form-group">
                      <div class="col-md-3">
                          <label >Ngày Chỉnh sửa</label>
                      </div>
                      <div class="col-md-9">
                          <input type="text" id="input-editday"  class="form-control">
                      </div>
                  </div>
              </form>
            </div>
            <!--modal footer-->
            <div class="modal-footer">
              <button class="btn btn-warning" id="btn-confirm" >Confirm</button>
              <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
            </div>
          </div>
      </div>
  </div>
  <!--Vùng modal-->
      
    </div><!-- /.container-fluid -->
    </section>
    <!-- /.content -->
  </div>
  <!-- /.content-wrapper -->
  <footer class="main-footer">
    <strong>Copyright &copy; 2014-2021 <a href="">Devcamp120.io</a>.</strong>
    All rights reserved.
    <div class="float-right d-none d-sm-inline-block">
      <b>Version</b> 3.2.0
    </div>
  </footer>

  <!-- Control Sidebar -->
  <aside class="control-sidebar control-sidebar-dark">
    <!-- Control sidebar content goes here -->
  </aside>
  <!-- /.control-sidebar -->
</div>
<!-- ./wrapper -->


<!-- jQuery -->
<script src="plugins/jquery/jquery.min.js"></script>
<!-- Bootstrap 4 -->
<script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
<script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>  
<script src="dist/js/adminlte.js"></script>
<!-- AdminLTE for demo purposes -->
<script src="dist/js/demo.js"></script>


<script>
  "use strict";
  $(document).ready(function(){
      //R1: vùng khai báo biến, hằng số, tham số Toàn cục
      var gDataOrders = []; //biến toàn cục (biến mảng) để lưu thông tin toàn bộ đơn hàng
      var gId;
      var gOrderId;
      var gPizzaSize = ["S","M","L"];
      const gORDER_COLS=["orderId","kichCo","loaiPizza","idLoaiNuocUong","thanhTien","hoTen","soDienThoai","trangThai","action"];
      //khai báo các cột của dataTable
      const gCOLUMN_ORDERID = 0;
      const gCOLUMN_KICHCO = 1;
      const gCOLUMN_LOAIPIZZA = 2;
      const gCOLUMN_ID_LOAINUOCUONG = 3;
      const gCOLUMN_THANHTIEN = 4;
      const gCOLUMN_HOTEN = 5;
      const gCOLUMN_SODIENTHOAI = 6;
      const gCOLUMN_TRANG_THAI = 7;
      const gCOLUMN_ACTION = 8;

      //định nghĩa table chưa có data
      $("#table-order").DataTable({
          columns: [
              {"data": gORDER_COLS[gCOLUMN_ORDERID]},
              {"data": gORDER_COLS[gCOLUMN_KICHCO]},
              {"data": gORDER_COLS[gCOLUMN_LOAIPIZZA]},
              {"data": gORDER_COLS[gCOLUMN_ID_LOAINUOCUONG]},
              {"data": gORDER_COLS[gCOLUMN_THANHTIEN]},
              {"data": gORDER_COLS[gCOLUMN_HOTEN]},
              {"data": gORDER_COLS[gCOLUMN_SODIENTHOAI]},
              {"data": gORDER_COLS[gCOLUMN_TRANG_THAI]},
              {"data": gORDER_COLS[gCOLUMN_ACTION]},
          ],
          //ghi đè nội dung cột Action, chuyển thành button chi tiết
          columnDefs: [
              {
                  "targets": gCOLUMN_ACTION,
                  "defaultContent": "<button class='btn-detail btn btn-primary'>Chi tiết</button>"
              }
          ]
      })
      //R2: Vùng gán/thực thi hàm xử lý sự kiện cho các elements
      onPageLoading()
      $("#table-order").on("click",".btn-detail",function(){
          onBtnDetailClick(this); //this là button được ấn
      })
      callAPIGetDrinksList();
      getPizzaSizeList(gPizzaSize)
      
      //gán sự kiện cho nút lọc
      $("#btn-filter").on("click", function(){
          onBtnFilterClick()
      })
      //R3: Vùng khai báo các hàm xử lý sự kiện
      function onPageLoading() {
          //lấy data từ server
      $.ajax({
          url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
          type: "GET",
          dataType: 'JSON',
          success: function(responseObject) {
              gDataOrders=responseObject;
              console.log (gDataOrders); 
              loadDataToTable(gDataOrders);
          },
          error: function(error) {
              console.assert(error.responseText);
          }
      })
      }
      //R4: Vùng khai báo hàm dùng chung cho toàn bộ chương trình
      //hàm đổ dữ liệu vào bảng
      function loadDataToTable(paramResponseObject){
          "use strict";
          var vUserTable = $("#table-order").DataTable();
          //xóa toàn bộ dữ liệu đang có của bảng
          vUserTable.clear();
          //Cập nhật data cho bảng
          vUserTable.rows.add(paramResponseObject);
          //hiển thị bảng đã cập nhật
          vUserTable.draw();
      }
      //hàm xử lý khi ấn nút chi tiết
      function onBtnDetailClick(paramBtnElement) {
          "use strict"
          var vRowSelected = $(paramBtnElement).closest("tr");
          var vTable = $("#table-order").DataTable()
          var vDataRow = vTable.row(vRowSelected).data();
          gId = vDataRow.id;
          gOrderId = vDataRow.orderId;
          console.log("Id: " + gId)
          console.log("OrderId: " + gOrderId)

          getAjaxOrderDetails(gOrderId);
          $("#Order-details-modal").modal("show")
      }

      //hàm filter data
      function onBtnFilterClick() {
          "use strict"
          var vStatus = $("#sel-status").val()
          var vPizzaType = $("#sel-pizza").val()
          var vDataFilter = gDataOrders.filter(function(paramOrder,index){
              return(vStatus == "all" || vStatus.toUpperCase() == paramOrder.trangThai.toUpperCase())
              && (vPizzaType == "all" || vPizzaType.toUpperCase() == paramOrder.loaiPizza.toUpperCase() )
          })
          loadDataToTable(vDataFilter)
      }

      //gọi API lấy select drink
      function callAPIGetDrinksList() {
          "use strict"
          $.ajax({
              url: "http://42.115.221.44:8080/devcamp-pizza365/drinks",
              type: "GET",
              dataType: "Json",
              success: function(res) {
                  handleDrinkList(res)
              },
              error: function(ajaxContext){
                  alert(ajaxContext.responseText);
              }
          })
      }

      //hàm tạo option cho select đồ uống
      function handleDrinkList(paramDrink) {
          $.each(paramDrink,function(i,item){
              $("#select-drink").append($("<option>",{
                  text: item.tenNuocUong,
                  value: item.maNuocUong
              }))
          })
      }

      //hàm tạo option cho select pizzaType
      function getPizzaSizeList(paramPizza) {
          $.each(paramPizza,function(i,item){
              $("#select-pizzasize").append($("<option>",{
                  text: item,
                  value: item.toLowerCase()
              }))
          })
      }

      //hàm gọi api lấy order detail theo orderId
      function getAjaxOrderDetails(paramOrderId) {
          "use strict"
          $.ajax({
              url: "http://42.115.221.44:8080/devcamp-pizza365/orders/" + paramOrderId,
              type: "GET",
              dataType: "JSON",
              success: function(res) {
                  handleOrderDetail(res)
                  console.log(res)
              },
              error: function(ajaxContext) {
                  alert(ajaxContext.responseText)
              }
          })
      }

      //hàm đổ data vào modal
      function handleOrderDetail(paramResponse) {
          "use strict"

          $("#input-id").val(paramResponse.id)
          $("#input-orderId").val(paramResponse.orderId)
          $("#select-pizzasize").val(paramResponse.kichCo.toLowerCase())
          $("#input-duongKinh").val(paramResponse.duongKinh);

          $("#input-suon").val(paramResponse.suon)
          $("#input-salad").val(paramResponse.salad)
          $("#input-pizzaType").val(paramResponse.loaiPizza)
          $("#input-idVoucher").val(paramResponse.idVourcher)

          $("#input-thanhtien").val(paramResponse.thanhTien)
          $("#input-giamgia").val(paramResponse.giamGia)
          $("#select-drink").val(paramResponse.idLoaiNuocUong)
          $("#input-soluongdrink").val(paramResponse.soLuongNuoc)

          $("#input-fullname").val(paramResponse.hoTen)
          $("#input-email").val(paramResponse.email)
          $("#input-phone").val(paramResponse.soDienThoai)
          $("#input-address").val(paramResponse.diaChi)

          $("#input-message").val(paramResponse.loiNhan)
          $("#input-orderday").val(paramResponse.ngayTao)
          $("#input-editday").val(paramResponse.ngayCapNhat)

      }
  })
</script>
</body>
</html>
